
<template>
    <el-container style="height: 100%">
        <el-header color="#333">
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
              <div class="tabControl">
                  <el-table :data="foodOrderList" style="width: 100%">
                    <el-table-column type="expand">
                      <template slot-scope="props">
                        <el-card class="el-card">
                          <el-row :gutter="200" class="el-row"  type="flex"  v-for="item in props.row.foodList" id=item :key="item.foodId">
                              <el-col :lg="6" :xs="2" style="height: 10px">
                                <img :src="item.foodImage" class="image" style="height: 200px;">
                              </el-col>
                              <el-col :lg="12" :xs="2" >
                                <el-form label-position="left" inline class="demo-table-expand">
                                  <el-form-item label="食品ID">
                                    <span>{{ item.foodId }}</span>
                                  </el-form-item>
                                  <el-form-item label="店铺ID">
                                    <span>{{ item.foodShopId }}</span>
                                  </el-form-item>
                                  <el-form-item label="食品名称">
                                    <span>{{ item.foodName }}</span>
                                  </el-form-item>

                                  <el-form-item label="价格">
                                    <span>{{ item.foodPrice }}</span>
                                  </el-form-item>
                                  <el-form-item label="卡路里">
                                    <span>{{ item.foodCalorie }}</span>
                                  </el-form-item>
                                  <el-form-item label="原料">
                                    <span>{{ item.foodIngredient }}</span>
                                  </el-form-item>
                                  <el-form-item label="状态:">
                                    <span >{{foodStatusName[item.foodTakeStatus]}}</span>
                                  </el-form-item>

                                  <el-form-item label="食物数量:">
                                    <span >{{ item.foodNumber }}</span>
                                  </el-form-item>
                                  <el-form-item label="类别:">
                                    <span >{{ item.foodCategory }}</span>
                                  </el-form-item>
                                  <el-form-item label="食品介绍:">
                                    <span >{{ item.foodIntroduction }}</span>
                                  </el-form-item>
                                  <el-form-item label="">
                                    <span></span>
                                  </el-form-item>
                                </el-form>
                              </el-col>
                          </el-row>
                            <el-row :gutter="200" class="el-row"  type="flex">
                              <el-col :lg="20" :xs="2" >
                                <el-form label-position="left" inline class="demo-table-expand">
                                  <el-form-item label="评论:">
                                    <span ><br>{{ props.row.foodOrderComment }}</span>
                                  </el-form-item>
                                  <el-form-item label="">
                                    <span></span>
                                  </el-form-item>
                                </el-form>
                              </el-col>
                            </el-row>
                          </el-card>
                      </template>
                    </el-table-column>
                    <el-table-column
                      label="订单号"
                      prop="foodOrderId">
                    </el-table-column>
                    <el-table-column
                      label="订单客户"
                      prop="user.userName">
                    </el-table-column>
                    <el-table-column
                      label="总价值"
                      prop="foodOrderPrice">
                    </el-table-column>
                    <el-table-column
                      label="总热量"
                      prop="foodOrderCalorie">
                    </el-table-column>
                    <el-table-column
                      label="配送地址"
                      prop="foodOrderLocation">
                    </el-table-column>
                    <el-table-column
                      label="配送方式"
                      :filters="[{text: '未选择', value: 0}, { text: '自取', value: 1 }, {text: '外送', value: 2}]"
                      :filter-method="filterMethodTag"
                      filter-placement="bottom-end">
                      <template slot-scope="scope">
                        <el-tag
                          :type="scope.row.foodOrderRiderSend ? 'success':'info'"
                          disable-transitions v-if="scope.row.foodOrderStatus !== 0">{{scope.row.foodOrderRiderSend ? '外送' : '自取'}}</el-tag>
                        <el-select v-model="scope.row.foodOrderRiderSend" placeholder="请选择" v-if="scope.row.foodOrderStatus === 0">
                          <el-option
                            v-for="item in options"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                          </el-option>
                        </el-select>
                      </template>
                    </el-table-column>
                  <el-table-column
                    label="订单状态"
                    :filters="[{text: '等待用户确认', value: 0 },{ text: '等待商户接单', value: 1 }, {text: '商户处理中', value: 2}, {text: '待骑手接单', value: 6}, {text: '待用户评价', value: 3}, {text: '订单已完成', value: 4}]"
                    :filter-method="filterStatusTag"
                    filter-placement="bottom-end">
                    <template slot-scope="scope">
                      <el-tag
                        :type="StatusType[scope.row.foodOrderStatus]"
                        disable-transitions>{{StatusName[scope.row.foodOrderStatus]}}</el-tag>
                    </template>
                  </el-table-column>
                  <el-table-column label="操作">
                    <template slot-scope="scope">
                      <el-button type="text" @click="UserOp(scope.row.index)" size="small" v-if="scope.row.foodOrderStatus === 1" :disabled = "disabled">确认</el-button>
                      <el-button type="text" @click="UserOp(scope.row.index)" size="small" v-if="scope.row.foodOrderStatus === 2" :disabled = "disabled">确认发货</el-button>
                    </template>
                  </el-table-column>
                </el-table>
              </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import OrderManage from '@/services/UserFoodOrderManager'
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import showViewInfoService from '@/services/showViewInfoService'
export default {
  components: {
    commonaside,
    commonheader
  },

  name: 'MerFoodManage',
  data () {
    return {
      activeName: 'rider',
      StatusType: [
        'info',
        'warning',
        'warning',
        'primary',
        'success',
        'error',
        'warning'
      ],
      StatusName: [
        '等待用户确认',
        '等待商户接单',
        '商户处理中',
        '待用户评价',
        '订单已完成',
        '未定义状态',
        '待骑手接单'
      ],
      foodStatusName: [
        '未认证',
        '认证待审核',
        '修改待审核',
        '认证不通过',
        '修改不通过',
        '审核通过'
      ],
      options: [{
        value: false,
        label: '自取'
      }, {
        value: true,
        label: '配送'
      }],
      foodOrderList: [{
      }],
      user: {
      },
      shopInfo: {
      },
      isAdmin: false,
      isFoodMerchant: false,
      comment: '',
      hasFalse: false,
      disabled: false
    }
  },
  created () {
    this.getOrderList()
  },
  methods: {
    async getOrderList () {
      try {
        var response = await showViewInfoService.getInfo({
          headers: {'Authorization': this.$store.state.token}
        })
        this.user = response.data.data.user
        this.isAdmin = false
        for (var j in this.user.roles) {
          if (this.user.roles[j] === 'admin') {
            this.isAdmin = true
          }
        }
        console.log('user')
        console.log(this.user.userId)
        const responsef = await OrderManage.getMerOrders(this.$route.params.id, {
          headers: {'Authorization': this.$store.state.token}
        })
        console.log(responsef)
        this.foodOrderList = responsef.data.data.foodOrderList
        for (var i = 0; i < this.foodOrderList.length; i++) {
          this.foodOrderList[i].index = i
        }
        this.$forceUpdate()
      } catch (error) {
        this.$message({
          showClose: true,
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg,
          type: 'error'
        })
      }
    },

    UComment (index) {
      if (this.foodOrderList[index].foodOrderStatus < 3) {
        this.$message({
          showClose: true,
          message: '订单状态未完成，无法评论',
          type: 'error'
        })
        this.disabled = false
        return
      }

      this.$prompt('请输入您的评论', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消'
      }).then(({ value }) => {
        this.comment = value
        this.UserOp(2, index)
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消评论'
        })
      })
    },
    async UserOp (index) {
      this.disabled = true
      try {
        var step = ''
        let response
        var ns
        if (this.foodOrderList[index].foodOrderStatus === 1) {
          step = '商店确认订单'
          ns = 2
        } else if (this.foodOrderList[index].foodOrderStatus === 2) {
          step = '商店处理餐品'
          ns = 6
        } else {
          step = ''
        }
        response = await OrderManage.Confirm({
          foodOrderId: this.foodOrderList[index].foodOrderId,
          nextStatus: ns
        }, this.foodOrderList[index].foodOrderId, ns, {
          headers: {'Authorization': this.$store.state.token}
        })
        console.log(response.data.code, response.data.msg)
        if (response.data === undefined || response.data.code !== 200) {
          this.hasFalse = true
          this.$message({
            showClose: true,
            message: step + (response.data === undefined ? '网络错误,无法访问' : response.data.msg),
            type: 'error'
          })
        } else {
          this.$message({
            showClose: true,
            message: step + response.data.msg,
            type: 'success'
          })
        }
      } catch (error) {
        this.disabled = false
        this.$message({
          showClose: true,
          message: step + (error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg),
          type: 'error'
        })
      }
      this.getOrderList()
      this.$forceUpdate()
      this.disabled = false
    },
    filterMethodTag (value, row) {
      if (value === 0) {
        return row.foodOrderStatus === 0
      } else if (value === 1) {
        return row.foodOrderRiderSend === false
      } else {
        return row.foodOrderRiderSend === true
      }
    },
    filterStatusTag (value, row) {
      console.log('val:' + value)
      return row.foodOrderStatus === value
    }
  }
}

</script>

<style scoped>
  .demo-table-expand {
    font-size: 0;
  }
  .demo-table-expand label {
    width: 90px;
    color: #99a9bf;
  }
  .demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
    width: 50%;
  }
  .el-header {
      background-color: #333;
  }
  .el-main {
      padding-top: 0;
  }
  .el-row {
  margin-bottom: 20px;
  display: flex;
  flex-wrap: wrap;
  }
  .el-col {
  border-radius: 0px;
  align-items: stretch;
  margin-bottom: 0px;
  margin-top: 30px;
  }
</style>
